# Inner structure

The *inner* structure of the app is located in `frontend/src/`

- [communicationLayer](../core/communication.md) the communication layer, functions to send/receive data
- `components` [components tutorial](../tutorials/components.md) contains all components of the app
- `helpers` a collection of helper functions, every file contains functions for a specific data/problem
- `questionSystem` contains files for the [question system](../core/questionSystem.md), the *questions* are the text for the exercise description
- `state` contains files for redux [redux tutorial](../tutorials/redux.md)
- `styles` contains some global styles for the app, see [styles tutorial](../tutorials/styles.md)
- `types` contains all *business* logic types (our types for our data), actually not well structured... [TODO??]
- `validation` contains files/functions for validation, see [validation](../tutorials/validation.md)
	- [not part of helpers because it feels more specific than helper functions]
- `allStyles.styl` contains all style files, see [styles tutorial](../tutorials/styles.md) why
- `app.tsx` the main site component, see [workflow](workflow.md)
- `constants.ts` some constants for the whole app
- `global.d.ts` defines (some) functions definitions e.g. *require* [TODO is this really needed anymore??]
- `index.tsx` the real root component of the app
- `routerHistory.ts` some functions/listeners for the router history
- `setup.ts` some setup stuff, see [setup](../core/setup.md)

## Components directory structure

The components directory is not that structured (could be better)...

However the folder `frontend/src/components/sites/` contains components for every visible site

All components that belong to only one site-component are located inside the site-component folder
But other components (also site-components) can use components from other site-components

e.g. the `consoleView` is used by many sites (do exercise, edit exercise, custom project, ...) but is located in the folder `frontend/src/components/sites/doExerciseSite/` [maybe change this??]

Other components are located outside of `frontend/src/components/sites/` and many of them are reusable

There are 2 components that are not located inside the components directory

- the root component
- the app component

How to check if a component is reusable? see [components](../tutorials/components.md##%20Reuseable%20components)

