# Setup

[Most of this was copied from setup for deployment]

The file describes how to setup the frontend used to deploy the app.

Actually YAPEX is build on top of platform independent technologies but some scripts are only available in unix (ubuntu/macos should work too)
Because of this the steps taken in the scripts are described here to reproduce them manually

Most of the time it is wanted that we setup backend, frontend & the other projects and for the structure it is helpful if we place them all inside one folder e.g. called `yapex`. We will refer to this common folder as `yapex` from now on

## 0 Requirements

You need to make sure you have the following programs installed
these should be accessible via the terminal/console without any path and by there common names (e.g. nodejs --> `node`)

- nodejs/npm
- git
- an editor/ide like WebStorm or Visual Studio Code

## 1 Get the code

```bash
cd yapex
git clone https://gitlab.informatik.uni-halle.de/Syndrom/frontend-react.git
cd frontend-react
```

All further steps assume you are in `yapex/frontend-react/`

## 2 Make sure we are in deploy mode & ports are right

Currently the file `frontend/deploy.ts` determines if we are in deploy mode and some port stuff.

You need to check the line

```ts
export const isProduction = false
```

that `isProduction` is set to `false`.

check also

```ts
export const debugOriginUrl = isProduction ? '' : 'http://localhost:5000'
```

and change the port from 5000 to the port used in the backend

Do this also for

```ts
export const debugApiHost = isProduction ? '/' :'http://localhost:5000/'
```


## 3 Get the libs

Because we use npm to manage libs and because there are sooooo many we don't ship them with the project (this saves us ~200MB of storage in gitlab)

So we download all libs with

```bash
npm install
```

this can take a while...

## 4 Run the dev server

To build the frontend just run the script located at `frontend/scripts/webpackDevServer.sh`

On windows (or if you don't want to use the script) do the following

```bash
npm run dev
```

The default port of the dev server is 8080, can be changed in `frontend/package.json` inside the `scripts` section in the `dev` command (somehow specify the port).

If you open the browser at [http://localhost:8080/index.html](http://localhost:8080/index.html) you should see the login site. It won't work until the backend is running but if you see the login side everything in the frontend compiled and is fine.

Now if the dev server is running and you modify a file (WebStorm has delayed writing which is good for this, so changed are only written if WebStorm lose focus or on save shortcut) the dev server will automatically recompile the bundle file (in memory) and reload the browser for you

## 5 Debugging and CORS

Because the frontend is served from webpack dev server at port 8080 and the backend runs on a different port (5000) the browser normally disallows the communication.
Because the frontend js tries to access a different origin.

See [https://spring.io/understanding/CORS](https://spring.io/understanding/CORS)

If the ports didn't change this is no problem. If it still don't work and you get some cors warning in the browser console do the following

In the backend check the `backend/src/ClientServer/appsettings.json` file and set the `DebugOriginUrl` option to the url used by the webpack dev server, normally `http://localhost:8080`
